#include <cstdio>
#include <vector>

using namespace std;

int timing[100000];

struct Order {
	long long id, t, a;
};

int main() {
	int man_count, flat_count;
	scanf("%d%d", &man_count, &flat_count);

	vector<Order> q;

	for (int i = 0; i < man_count; i++) {
		int t, a;
		scanf("%d%d", &t, &a);
		Order o;
		o.id = i;
		o.t = t;
		o.a = a;
		q.push_back(o);
	}

	long long m = 0;
	while (!q.empty()) {
		long long r = q[0].t > m ? q[0].t : m;
		long long a = q[0].a;
		long long t = r + a - 1;
		m = t + a - 1;
		for (vector<Order>::iterator iter = q.begin(); iter != q.end(); ++iter) {
			if (iter->a <= a && iter->t - t <= a - iter->a) {
				timing[iter->id] = m;
				q.erase(iter, iter + 1);
				--iter;
			}
		}
	}

	for (int i = 0; i < man_count; i++) {
		printf("%d\n", timing[i]);
	}
}

