k, n, m = (int(s) for s in input().split())
c = [0] * n
v = [0] * n

for i in range(n):
    c[i], v[i] = (int(s) for s in input().split())

pos = [0] * n
for i in range(1, n):
    pos[i] = pos[i - 1] + c[i - 1]

def delta_at(p: int):
    l = 0
    r = n
    while l + 1 < r:
        m = l + (r - l) // 2
        if pos[m] <= p:
            l = m
        else:
            r = m
    return l

def recursion(l: int, r: int, f: int):
    dl = delta_at(l)
    dr = delta_at(r - 1)

    res_l = 0
    if f != v[dl]:
        res_l = 1

    res_r = 0
    if f != v[dr]:
        res_r = 1

    if dr == dl:
        return res_l

    ll = recursion(l, (l + r) // 2, v[dl])
    lr = recursion((l + r) // 2, r, v[dl])
    rl = recursion(l, (l + r) // 2, v[dr])
    rr = recursion((l + r) // 2, r, v[dr])

    # print(l, r, f, dl, dr, res_l, ll, lr, res_r, rl, rr)

    return min(res_l + ll + lr, res_r + rl + rr)

print(recursion(0, 2 ** k, 0))
# print(recursion(0, 1, 0))
