def square(x: int):
    return x * x

def cube(x: int):
    return x * x * x

def seek_sqrt(val: int):
    l = 0
    r = val + 1
    while l + 1 < r:
        m = l + (r - l) // 2
        if square(m) < val:
            l = m
        else:
            r = m
    return l + 1

def seek_cbrt(val: int):
    l = 0
    r = val + 1
    while l + 1 < r:
        m = l + (r - l) // 2
        if cube(m) < val:
            l = m
        else:
            r = m
    return l + 1

a = int(input())
b = int(input())
k = int(input())

x_begin = seek_sqrt(a)
y_begin = seek_cbrt(a)
result = 0

y_min = y_begin
y_max = y_begin
x = x_begin

while square(x) <= b:
    while cube(y_min + 1) <= b and cube(y_min) + k < square(x):
        y_min += 1

    while cube(y_max + 1) <= b and cube(y_max + 1) <= square(x) + k:
        y_max += 1

    if y_min <= y_max and cube(y_max) + k >= square(x) and cube(y_min) <= square(x) + k:
        result += y_max - y_min + 1

    x += 1

print(result);

