def square(x: int):
    return x * x

def cube(x: int):
    return x * x * x

def seek_sqrt(val: int):
    l = 0
    r = val + 1
    while l + 1 < r:
        m = l + (r - l) // 2
        if square(m) < val:
            l = m
        else:
            r = m
    return l + 1

def seek_cbrt(val: int):
    l = 0
    r = val + 1
    while l + 1 < r:
        m = l + (r - l) // 2
        if cube(m) < val:
            l = m
        else:
            r = m
    return l + 1

a = int(input())
b = int(input())
k = int(input())

x_begin = seek_sqrt(a)
y_begin = seek_cbrt(a)
result = 0

y = y_begin
x_min = x_begin
x_max = x_begin

while cube(y) <= b:
    while square(x_min + 1) <= b and square(x_min) + k < cube(y):
        x_min += 1

    while square(x_max + 1) <= b and square(x_max + 1) <= cube(y) + k:
        x_max += 1

    if x_min <= x_max and square(x_max) + k >= cube(y) and square(x_min) <= cube(y) + k:
        result += x_max - x_min + 1

    y += 1

print(result)

