def numsum(k, n):
    return (n * (n + 1) - k * (k + 1)) // 2

def binseek(k, s):
    l = k + 1
    r = s
    while l + 1 < r:
        m = l + (r - l) // 2
        if numsum(k, m) < s:
            l = m
        else:
            r = m
    return l

k = int(input())
s = int(input())

u = binseek(k, s)
diff = s - numsum(k, u)
res = k + diff // (u - k)
if diff % (u - k) != 0:
    res += 1
print(res)
