k, n, m = (int(s) for s in input().split())
c = [0] * n
v = [0] * n

for i in range(n):
    c[i], v[i] = (int(s) for s in input().split())

pos = [0] * n
for i in range(1, n):
    pos[i] = pos[i - 1] + c[i - 1]

def delta_at(p: int):
    l = 0
    r = n
    while l + 1 < r:
        m = l + (r - l) // 2
        if pos[m] <= p:
            l = m
        else:
            r = m
    return l

def recursion(l: int, r: int, f: int):
    dl = delta_at(l)
    dr = delta_at(r - 1)

    if dr == dl:
        if f == v[dl]:
            return 0
        else:
            return 1

    res = []
    for i in range(dl, dr + 1):
        val = v[i]
        result = 0 if val == f else 1
        rl = recursion(l, (l + r) // 2, val)
        rr = recursion((l + r) // 2, r, val)
        res.append(result + rl + rr)
        
    return min(res)

print(recursion(0, 2 ** k, 0))
# print(recursion(0, 1, 0))
